# Table

The styling wrapper on the [Bootstrap-Vue b-table](https://bootstrap-vue.js.org/docs/components/table) component.

<!-- STORY -->

### Usage

```html
<e-panel :title="'New Users'" :subtitle="'For the week'">
  <template slot="actions">
    <small class="text-muted">{{ tableStatus }}</small>
  </template>
  <b-table class="fa-sort-icons table-rounded mt-3 mb-0"
    :items="items"
    :fields="fields"
    :per-page="perPage"
    :current-page="currentPage"
    responsive
    bordered>
    <template slot="#" slot-scope="data">
      <b>{{ (perPage * (currentPage - 1)) + data.index + 1 }}</b>
    </template>
    <template slot="status" slot-scope="data">
      <span class="badge" :class="data.value ? 'badge-light' : 'badge-secondary'">{{ data.value }}</span>
    </template>
    <template slot="date" slot-scope="data">
      <span>{{ data.item.date | moment('DD MMM YYYY') }}</span>
    </template>
  </b-table>
  <b-pagination class="pagination-separated mt-3 mb-0" size="sm" align="center" :total-rows="items.length" :per-page="perPage" v-model="currentPage" />
</e-panel>
```
```js
import EPanel from 'elements/panel'

const items = [
  { name: 'Adam Cotter',        date: 1512792908, status: true  },
  { name: 'Pauline Noble',      date: 1516977768, status: false },
  { name: 'Sherilyn Metzel',    date: 1517042476, status: true  },
  { name: 'Terrie Boaler',      date: 1516439865, status: true  },
  { name: 'Rutter Pude',        date: 1515850922, status: false },
  { name: 'Clifford Benjamin',  date: 1516898701, status: true  },
  { name: 'Thedric Romans',     date: 1515707885, status: false },
  { name: 'Haily Carthew',      date: 1517056707, status: true  },
  { name: 'Dorothea Joicey',    date: 1513090469, status: true  },
  { name: 'Mikaela Pinel',      date: 1512892304, status: false },
  { name: 'Donnell Farries',    date: 1512299369, status: true  },
  { name: 'Letizia Puncher',    date: 1512769349, status: false },
  { name: 'Kania Yallowley',    date: 1515521487, status: true  },
  { name: 'Clay De Francesco',  date: 1515012234, status: false },
  { name: 'Ina Queree',         date: 1514458367, status: false },
  { name: 'Rasia Awty',         date: 1516943842, status: false },
  { name: 'Basil Crosham',      date: 1512108299, status: true  },
  { name: 'Alexis Dodworth',    date: 1516814115, status: false },
  { name: 'Greg Onyon',         date: 1517071308, status: true  },
  { name: 'Barry Carbett',      date: 1515450742, status: true  },
  { name: 'Carlyle Adran',      date: 1512498261, status: true  },
  { name: 'Guillaume Petel',    date: 1512742913, status: false },
  { name: 'Wendeline Glasner',  date: 1513319267, status: false },
  { name: 'Sylvia Petrollo',    date: 1516080489, status: false },
  { name: 'Meade Quoit',        date: 1513972299, status: true  },
  { name: 'Eugine Planke',      date: 1515488407, status: false },
  { name: 'Thoma Drakeley',     date: 1515023660, status: false },
  { name: 'Web Margetson',      date: 1513557231, status: true  },
  { name: 'Erskine Stivens',    date: 1515233788, status: true  },
  { name: 'Jedidiah Emmer',     date: 1512614842, status: false },
  { name: 'Wolfie Drakers',     date: 1512381522, status: false },
  { name: 'Allie Quiney',       date: 1515488202, status: true  }
]

const fields = [
  { key: '#', label: '#', thClass: 'text-center', tdClass: 'text-center' },
  { key: 'name', thClass: 'max-width', tdClass: 'text-nowrap' },
  { key: 'date', tdClass: 'text-nowrap', sortable: true },
  { key: 'status', tdClass: 'text-center align-middle' }
]

export default {
  components: { EPanel },
  data: function() {
    return {
      items,
      fields,
      currentPage: 1,
      perPage: 3
    }
  },
  computed: {
    tableStatus: function() {
      let itemsTotal = this.items.length,
          itemsFrom = (this.perPage * (this.currentPage - 1)) + 1,
          itemsTo = Math.min(itemsFrom + this.perPage - 1, itemsTotal);
      return `${itemsFrom} - ${itemsTo} of ${itemsTotal}`
    }
  }
}
```

### Props and Slots
For the complete table configuration notes, please, refer to the original [Bootstrap-Vue b-table](https://bootstrap-vue.js.org/docs/components/table) documentation.

### See Also
- [Bootstrap-Vue b-table](https://bootstrap-vue.js.org/docs/components/table)
